// **********************************************************************
//
// Copyright (c) 2001 MT Tools.
//
// All Rights Reserved
//
// MT_DORB is based in part on the product DORB,
// written by Shadrin Victor
//
// See Readme.txt for contact information
//
// **********************************************************************
unit except_int;

interface

uses
  code_int,classes,types;

type

  IORBException = interface(IUnknown)
  ['{61252F7A-4D23-11d4-9D27-204C4F4F5020}']
    procedure encode(const enc: IEncoder);
    procedure encode_any(const a: IAny);
    function clone(): IORBException;
    procedure print(s: TStream);
    function repoid(): PChar;
    procedure throw();
    function ref_count(): integer;
  end;

  ISystemException = interface(IORBexception)
  ['{61252F7B-4D23-11d4-9D27-204C4F4F5020}']
    procedure assign(const ex: ISystemException);
    function completed(): TCompletionStatus;
    function minor(): _ulong;
    procedure set_minor(val: _ulong);
    procedure set_completed(val: TCompletionStatus);
    function extype(): SYSEXC_TYPES;
  end;

  IUserException = interface(IORBException)
  ['{FBB86C41-9AF8-11d4-9DB2-204C4F4F5020}']

  end;

  IUnknownUserException = interface(IUserException)
  ['{61252F7C-4D23-11d4-9D27-204C4F4F5020}']
    function exception(tc: ITypeCode): IAny; overload;
    function exception(sa: IStaticTypeInfo): IStaticAny; overload;
    function except_repoid: string;
  end;

  IBadKind = interface(IUserException)
  ['{FBB86C42-9AF8-11d4-9DB2-204C4F4F5020}']
  end;

  IBounds = interface(IUserException)
  ['{FBB86C43-9AF8-11d4-9DB2-204C4F4F5020}']
  end;

implementation



end.
